"""
Ici nous définirons la classe 'Personnage'
"""


class Personnage:
    def __init__(self, nom):
        self.nom = nom
        self.vie = 100
        self.mana = 50
        self.stamina = 100
        self.esquive = False
        self.potions = 2

    def __str__(self):
        return self.nom+" : PV = "+str(self.vie)+" , PA = "+str(self.mana)+" , PM = "+str(self.stamina)

    def esquiver(self):
        if self.stamina >= 20:
            self.stamina -= 20
            self.esquive = True
            print(self.nom+" se prépare à esquiver")
        else:
            self.esquive = False
            print(self.nom+" échoue de manière ridicule")

    def boire(self):
        if self.potions > 0:
            self.vie += 70
            print(self.nom+" se requinque")
            if self.vie > 100:
                self.vie = 100

    def mourir(self):
        print(self.nom+" : AAAH *!/•@ stpgh")
        print(self.nom+" est mort...")

    def prendre_des_degats(self, degats):
        if self.esquive:
            self.esquive = False
            print(self.nom+" esquive l'attaque")
        else:
            self.vie -= degats
            if self.vie <= 0:
                self.mourir()

    def se_concentrer(self):
        self.mana += 40
        print(self.nom+" se concentre")
        if self.mana > 50:
            self.mana = 50
